/* **********************************************************
 * Copyright (C) 1998-2000 VMware, Inc.
 * All Rights Reserved
 * **********************************************************/

#ifndef __DRIVER_H__
#define __DRIVER_H__

#include <linux/sched.h>
#include <linux/miscdevice.h>

#include "x86.h"
#include "vm_types.h"
#include "vm_time.h"


/*
 * Per-instance driver state
 */

struct VMDriver;

typedef struct VMLinux {
   struct VMLinux *next;
   struct VMDriver *vm;

   /*
    * for LinuxDriver_Select()
    */

   Bool selectWaiting;
#ifndef KERNEL_2_3_1
   struct wait_queue *selectQueue;
#else
   wait_queue_head_t selectQueue;
#endif
   struct timer_list selectTimer;

} VMLinux;


/*
 * Static driver state.
 */

#define DEVICE_NAME_SIZE 32
#define LINUXLOG_BUFFER_SIZE  1024

typedef struct VMXLinuxState {
   int major;
   int minor;
   struct miscdevice misc;
   VmTimeStart startTime;	/* Used to compute Mhz estimate */
   char deviceName[DEVICE_NAME_SIZE];
   char buf[LINUXLOG_BUFFER_SIZE];
   VMLinux *head;
} VMXLinuxState;

extern VMXLinuxState linuxState;


#endif
